//***************************************************************************
//* LANIOCu wb_t@C
//***************************************************************************

#ifdef EXPORT_DECLSPEC
#define DECLSPEC extern "C" __declspec(dllexport) int __stdcall
#else
#define DECLSPEC extern "C" __declspec(dllimport) int __stdcall
#endif

//***************************************************************************
//* ^`A萔`
//***************************************************************************

//***************************************************************************
//* LANIOnh
//***************************************************************************
#define hLANIO int

//***************************************************************************
//* LELanioGetLastErrorԂG[R[h
//***************************************************************************
enum LANIOERROR {
	LELANIOERR_NOINIT = 1,			//* Ă܂BLELanioInitsĂB
	LELANIOERR_NOLANIO,				//* ʁALANIOł܂łB
	LELANIOERR_NOTEXIST,			//* ŔLANIO葽lw肵܂B
	LELANIOERR_NOTFOUND,			//* w肳ꂽLANIO𔭌ł܂łB
	LELANIOERR_NOCONNECTED,			//* LANIOƐڑĂ܂BLELanioConnectsĂB
	LELANIOERR_INVALIDOPERATION,	//* w肳ꂽ͎sł܂B
	LELANIOERR_ALREADY_CONNECTED,	//* łɐڑĂ܂B
	LELANIOERR_OVERCONNECTMAX,		//* ڑő吔𒴉߂܂B
	LELANIOERR_INVALIDRETURNVALUE,	//* sȖ߂lԂ܂B
};

//***************************************************************************
//* LELanioGetModelŎ擾LANIOf
//***************************************************************************
enum LANIOMODEL {
	LA2R3PP = 0,
	LA3R2P  = 1,		// LA-3R2P-P܂
	LA7P    = 2,		// LA-7P-P / LA-7P-A܂
	LA5R    = 3,
	LA5T2S  = 4,		// LA-5T2S-P܂
	LA5PP   = 5,
	LA3R3PP = 6,
	LA232R  = 7,
	LA232T  = 8,
	LA485R  = 9,
	LA485T  = 10,
	LA4R4PP = 16+1,
	LA8R    = 16+3,
	LA8T    = 16+4,
	LA8PP   = 16+5,
	LA4T4SP = 16+6,
	LAN2R2P = 24+1,
	NO_GETMODEL = -1,
};

//***************************************************************************
//* AIAG[擾֐
//***************************************************************************

//***************************************************************************
//*		LANIOCu܂B
//***************************************************************************
DECLSPEC LELanioInit();

//***************************************************************************
//*		LANIOCu̎gpI܂B
//***************************************************************************
DECLSPEC LELanioEnd();

//***************************************************************************
//*		OɔG[ԍ擾܂B
//*		߂l : G[̏Ԃ܂
//***************************************************************************
DECLSPEC LELanioGetLastError();

//***************************************************************************
//*		̃lbg[NfoCXƂAgpfoCXI܂
//*		   : ipaddress  gpfoCXIPAhX
//***************************************************************************
DECLSPEC LELanioSelectNetworkDevice(char *ipaddress);

//***************************************************************************
//* LANIO֐
//***************************************************************************

//***************************************************************************
//*		ILANIOIDModel擾@\ɂĂ̐ݒ܂B
//*		   : enable  ̋@\gpꍇTRUE(1)AȂꍇFALSE(0)
//*		         port    IDModel擾VÃ|[gԍ
//***************************************************************************
DECLSPEC LELanioSetAutoRequestIdModel(BOOL enable, int port);

//***************************************************************************
//*		LANɂLANIO܂B
//*		   : msec    ^CAEgԁiP mbj
//*		߂l : LANIO̐BłȂꍇ0BG[-1
//***************************************************************************
DECLSPEC LELanioSearch(int msec = 100);

//***************************************************************************
//* LANIO擾֐
//***************************************************************************

//***************************************************************************
//*		LANIOIPAhX擾܂B
//*		   : lanio       LANIOԍ
//*		         ipaddress   IPAhX擾obt@ւ̃|C^(16byteKv)
//***************************************************************************
DECLSPEC LELanioGetIpAddress(int lanio, char *ipaddress);

//***************************************************************************
//*		LANIOMACAhX擾܂B
//*		   : lanio       LANIOԍ
//*		         macaddress  MACAhX擾obt@ւ̃|C^(6byteKv)
//***************************************************************************
DECLSPEC LELanioGetMacAddress(int lanio, unsigned char *macaddress);

//***************************************************************************
//*		LANIOIDԍ擾܂B
//*		   : lanio   LANIOԍ
//*		         id      LANIOID擾obt@ւ̃|C^
//***************************************************************************
DECLSPEC LELanioGetId(int lanio, int *id);

//***************************************************************************
//*		LANIÕf擾܂B
//*		   : lanio   LANIOԍ
//*		         model   LANIÕf擾obt@ւ̃|C^
//***************************************************************************
DECLSPEC LELanioGetModel(int lanio, int *model);

//***************************************************************************
//*		LANIOɑ΂IDƃfԍ₵܂B
//*		   : lanio   LANIOԍ
//*		         id      LANIOID擾obt@ւ̃|C^
//*		         model   LANIÕf擾obt@ւ̃|C^
//***************************************************************************
DECLSPEC LELanioRequestIdModel(int lanio, int *id, int *model);

//***************************************************************************
//* LANIOڑ֐
//***************************************************************************

//***************************************************************************
//*		LELanioSearchɂĔꂽԂw肵Đڑ܂B
//*		   : lanio   LANIOԍ
//*		߂l : G[-1AILANIOnhԂ܂
//***************************************************************************
DECLSPEC LELanioConnect(int lanio);

//***************************************************************************
//*		IDƃfw肵Đڑ܂B
//*		   : id      LANIOIDԍ
//*		         model   LANIÕf
//*		߂l : G[-1AILANIOnhԂ܂
//***************************************************************************
DECLSPEC LELanioConnectByIdModel(int id, int model);

//***************************************************************************
//*		IPAhXw肵Đڑ܂B
//*		   : ipaddress   IPAhXobt@ւ̃|C^
//*		߂l : G[-1AILANIOnhԂ܂
//***************************************************************************
DECLSPEC LELanioConnectByIpAddress(char *ipaddress);

//***************************************************************************
//*		MACAhXw肵Đڑ܂B
//*		   : macaddress  MACAhXobt@ւ̃|C^
//*		߂l : G[-1AILANIOnhԂ܂
//***************************************************************************
DECLSPEC LELanioConnectByMacAddress(unsigned char *macaddress);

//***************************************************************************
//*		IPAhXURLw肵Đڑ܂B
//*		   : address IPAhX܂urlobt@ւ̃|C^
//*		         msec    ^CAEgԁiP mbj
//*		߂l : G[-1AILANIOnhԂ܂
//***************************************************************************
DECLSPEC LELanioConnectDirect(char *address, int msec = 1000);

//***************************************************************************
//*		IPAhXURLA|[gԍw肵Đڑ܂BڑUDPgp܂B
//*		   : address    IPAhX܂urlobt@ւ̃|C^
//*		         msec       ^CAEgԁiP mbj
//*		         serialport |[gԍ
//*		߂l : G[-1AILANIOnhԂ܂
//***************************************************************************
DECLSPEC LELanioConnectDirect2(char *address, int msec = 1000, int serialport = 10003 );

//***************************************************************************
//* LANIOؒf֐
//***************************************************************************

//***************************************************************************
//*		LANIOƂ̐ڑؒf܂B
//*		   : handle  LANIOnh
//***************************************************************************
DECLSPEC LELanioClose(hLANIO handle);

//***************************************************************************
//* o͊֐
//***************************************************************************

//***************************************************************************
//*		LANIODO𑀍삵܂B_Pʂ̑Ɏgp܂B
//*		   : handle  LANIOnh
//*		         pio     삷DO|[gԍBDO1=0ADO2=1...
//*		         active  ONȂ1AOFFȂ0
//***************************************************************************
DECLSPEC LELanioOutPio(hLANIO handle, int pio, BOOL active);

//***************************************************************************
//*		LANIODO𑀍삵܂BSĂDOɑ΂Ăɑ삷鎞Ɏgp܂B
//*		   : handle  LANIOnh
//*		         piobit  DO|[g̐ݒBŉʃrbgDO1ADO2...ɑΉ܂
//***************************************************************************
DECLSPEC LELanioOutPioAll(hLANIO handle, int piobit);

//***************************************************************************
//*		LANIODI擾܂B_Pʂ̎擾Ɏgp܂B
//*		   : handle  LANIOnh
//*		         pio     擾DI|[gԍBDI1=0ADI2=1...ɑΉ܂
//*		         active  ONȂ1AOFFȂ0obt@ւ̃|C^
//***************************************************************************
DECLSPEC LELanioInPio(hLANIO handle, int pio, BOOL *active);

//***************************************************************************
//*		LANIODI擾܂BSĂDIɑ΂ĂɎ擾鎞Ɏgp܂B
//*		   : handle  LANIOnh
//*		         piobit  DI|[g̓eobt@ւ̃|C^
//*		                 ŉʃrbgDI1ADI2...
//***************************************************************************
DECLSPEC LELanioInPioAll(hLANIO handle, int *piobit);

//***************************************************************************
//*		LANIǑ݂DOԂ擾܂B_Pʂ̎擾Ɏgp܂B
//*		   : handle  LANIOnh
//*		         pio     擾DO|[gԍBDO1=0ADO2=1...ɑΉ܂
//*		         active  ONȂ1AOFFȂ0obt@ւ̃|C^
//***************************************************************************
DECLSPEC LELanioGetOut(hLANIO handle, int pio, BOOL *active);

//***************************************************************************
//*		LANIǑ݂DOԂ擾܂BSĂDOɑ΂ĂɎ擾鎞Ɏgp܂B
//*		   : handle  LANIOnh
//*		         piobit  DO|[g̓eobt@ւ̃|C^
//*		                 ŉʃrbgDO1ADO2...
//***************************************************************************
DECLSPEC LELanioGetOutAll(hLANIO handle, int *piobit);

//***************************************************************************
//*		LANIȌo͒[qON/OFF̊Jn/~s܂
//*		   : handle  LANIOnh
//*		         active  ON/OFFJn=0ȊOA~=0
//***************************************************************************
DECLSPEC LELanioSetAutoSwitchingActive(hLANIO handle, BOOL active);

//***************************************************************************
//*		LANIȌo͒[qON/OFF̊Jn/~ݒ擾܂
//*		   : handle  LANIOnh
//*		         active  ON/OFFԂobt@ւ̃|C^
//***************************************************************************
DECLSPEC LELanioGetAutoSwitchingActive(hLANIO handle, BOOL *active);

//***************************************************************************
//*		LANIȌo͒[qON/OFF̎ݒ肵܂
//*		   : handle  LANIOnh
//*		         msec    iP mbj
//***************************************************************************
DECLSPEC LELanioSetAutoSwitchingTime(hLANIO handle, int msec);

//***************************************************************************
//*		LANIȌo͒[qON/OFF̎ݒ擾܂
//*		   : handle  LANIOnh
//*		         msec    iP mbjobt@ւ̃|C^
//***************************************************************************
DECLSPEC LELanioGetAutoSwitchingTime(hLANIO handle, int *msec);

//***************************************************************************
//*		LANIȌo͒[qON/OFFsDOݒ肵܂B
//*		   : handle  LANIOnh
//*		         autoswdo ŉʃrbgADO1`DO5ŎON/OFFs[q1
//***************************************************************************
DECLSPEC LELanioSetAutoSwitchingPio(hLANIO handle, int autoswdo);

//***************************************************************************
//*		LANIȌo͒[qON/OFFsDOݒ擾܂
//*		   : handle  LANIOnh
//*		         autoswdo ON/OFFsDOݒ擾obt@ւ̃|C^
//***************************************************************************
DECLSPEC LELanioGetAutoSwitchingPio(hLANIO handle, int *autoswdo);

//***************************************************************************
//*		8_^CvLANIȌo͒[qON/OFF̃`lʎݒ肵܂
//*		   : handle   LANIOnh
//*		         pio      ݒ肷DO|[gԍBDO1=0ADO2=1...ɑΉ܂
//*		         msec_on  ONԁi100msecPʁAݒ͈1-25500j
//*		         msec_off OFFԁi100msecPʁAݒ͈1-25500j
//***************************************************************************
DECLSPEC LELanioSetAutoSwitchingChannel(hLANIO handle, int pio, int msec_on, int msec_off);

//***************************************************************************
//*		8_^CvLANIȌo͒[qON/OFF̃`lʎݒ擾܂
//*		   : handle   LANIOnh
//*		         pio      擾DO|[gԍBDO1=0ADO2=1...ɑΉ܂
//*		         msec_on  ONԁi100msecPʁj
//*		         msec_off OFFԁi100msecPʁj
//***************************************************************************
DECLSPEC LELanioGetAutoSwitchingChannel(hLANIO handle, int pio, int *msec_on, int *msec_off);

//***************************************************************************
//*		LANIO̖ʐMԂɂȂ̐ڑێԂݒ肷
//*		   : handle  LANIOnh
//*		         time    
//*		                 0x00:ؒf 0x04: 3sec  0x08:50sec  0x0c:10min
//*		                 0x01:300ms    0x05: 5sec  0x09: 1min  0x0d:30min
//*		                 0x02:500ms    0x06:10sec  0x0a: 3min  0x0e:50min
//*		                 0x03: 1sec    0x07:30sec  0x0b: 5min  0x0f:
//***************************************************************************
DECLSPEC LELanioSetDisconnectionTime(hLANIO handle, int time);

//***************************************************************************
//*		LANIO̖ʐMԂɂȂ̐ڑێԂ擾
//*		   : handle  LANIOnh
//*		         time    Ԃ擾obt@ւ̃|C^
//*		                 0x00:ؒf 0x04: 3sec  0x08:50sec  0x0c:10min
//*		                 0x01:300ms    0x05: 5sec  0x09: 1min  0x0d:30min
//*		                 0x02:500ms    0x06:10sec  0x0a: 3min  0x0e:50min
//*		                 0x03: 1sec    0x07:30sec  0x0b: 5min  0x0f:
//***************************************************************************
DECLSPEC LELanioGetDisconnectionTime(hLANIO handle, int *time);

//***************************************************************************
//*		LANIO̒ʒmԂݒ肷
//*		   : handle  LANIOnh
//*		                 0x00:ʒmȂ 0x04: 3min     0x08:ݒ֎~  0x0c:ݒ֎~
//*		                 0x01:10sec    0x05:ݒ֎~  0x09:ݒ֎~  0x0d:ݒ֎~
//*		                 0x02:30sec    0x06:ݒ֎~  0x0a:ݒ֎~  0x0e:ݒ֎~
//*		                 0x03:60sec    0x07:ݒ֎~  0x0b:ݒ֎~  0x0f:ݒ֎~
//***************************************************************************
DECLSPEC LELanioSetNoticeTime(hLANIO handle, int time);

//***************************************************************************
//*		LANIO̒ʒmԂ擾
//*		   : handle  LANIOnh
//*		                 0x00:ʒmȂ 0x04: 3min   0x08:  ---   0x0c:  ---
//*		                 0x01:10sec    0x05:  ---   0x09:  ---   0x0d:  ---
//*		                 0x02:30sec    0x06:  ---   0x0a:  ---   0x0e:  ---
//*		                 0x03:60sec    0x07:  ---   0x0b:  ---   0x0f:  ---
//***************************************************************************
DECLSPEC LELanioGetNoticeTime(hLANIO handle, int *time);

//***************************************************************************
//*		LANIÕ`^O̊Ԃݒ肷
//*		   : handle  LANIOnh
//*		         time    (msP 4ms`20msj
//***************************************************************************
DECLSPEC LELanioSetDiDetectTime(hLANIO handle, int time);

//***************************************************************************
//*		LANIÕ`^O̊Ԃ擾
//*		   : handle  LANIOnh
//*		         time    Ԃ擾obt@ւ̃|C^(msP 4ms`20msj
//***************************************************************************
DECLSPEC LELanioGetDiDetectTime(hLANIO handle, int *time);

//***************************************************************************
//*		LANIÕ[A[gs͒[qݒ肵܂
//*		   : handle  LANIOnh
//*		         enable  [A[gsrbg1Ŏw
//*		                 ŉʃrbgDI1ADI2...
//***************************************************************************
DECLSPEC LELanioSetDiMailEnable(hLANIO handle, int enable);

//***************************************************************************
//*		LANIÕ[A[gs͒[q擾܂
//*		   : handle  LANIOnh
//*		         enable  [A[gsrbg1Ŏw
//*		                 ŉʃrbgDI1ADI2...
//***************************************************************************
DECLSPEC LELanioGetDiMailEnable(hLANIO handle, int *enable);

//***************************************************************************
//*		LANIÕ[A[gs_Ԃݒ肵܂
//*		   : handle  LANIOnh
//*		         logic   HIŃ[A[gsrbg1Ŏw
//*		                 ŉʃrbgDI1ADI2...
//***************************************************************************
DECLSPEC LELanioSetDiMailLogic(hLANIO handle, int logic);

//***************************************************************************
//*		LANIÕ[A[gs_Ԃ擾܂
//*		   : handle  LANIOnh
//*		         logic   HIŃ[A[gsrbg1Ŏw
//*		                 ŉʃrbgDI1ADI2...
//***************************************************************************
DECLSPEC LELanioGetDiMailLogic(hLANIO handle, int *logic);

//***************************************************************************
//*		PulseModeɓ܂
//*		   : handle  LANIOnh
//***************************************************************************
DECLSPEC LELanioPulseModeOn(hLANIO handle);

//***************************************************************************
//*		PulseModeI܂
//*		   : handle  LANIOnh
//***************************************************************************
DECLSPEC LELanioPulseModeOff(hLANIO handle);

//***************************************************************************
//*		PulseModeԂ擾܂
//*		   : handle  LANIOnh
//*		         mode    PulseModeԁB[hȂ1A[hłȂ0
//***************************************************************************
DECLSPEC LELanioPulseModeGetState(hLANIO handle, int *mode);

//***************************************************************************
//*		PulseModẽpX擾܂
//*		   : handle  LANIOnh
//*		         value   pXBI[o[t[Ԃ̏ꍇ-1
//***************************************************************************
DECLSPEC LELanioPulseModeGetCount(hLANIO handle, int *value);

//***************************************************************************
//*		PulseMode̐ݒ܂
//*		   : handle  LANIOnh
//*		         pio     삷DI|[gԍBDI1=0ADI2=1...
//*		         edge    0ŗオA1ŗGbW
//*		         time    莞
//*		                 0:START-STOP  1:100msec  2:1sec  3:10sec
//*		         chatter `^O}
//*		                 0:Ȃ  1`3:ݒs  4`20:4`20msec
//***************************************************************************
DECLSPEC LELanioPulseModeSetConfig(hLANIO handle, int pio, BOOL edge, int time, int chatter);

//***************************************************************************
//*		PulseMode̐ݒ擾܂
//*		   : handle  LANIOnh
//*		         pio     삷DI|[gԍBDI1=0ADI2=1...
//*		         edge    0ŗオA1ŗGbW
//*		         time    莞
//*		                 0:START-STOP  1:100msec  2:1sec  3:10sec
//*		         chatter `^O}
//*		                 0:Ȃ  1`3:ݒs  4`20:4`20msec
//***************************************************************************
DECLSPEC LELanioPulseModeGetConfig(hLANIO handle, int *pio, BOOL *edge, int *time, int *chatter);

//***************************************************************************
//*		pXAJn܂
//*		   : handle  LANIOnh
//***************************************************************************
DECLSPEC LELanioPulseModeContinuesOn(hLANIO handle);

//***************************************************************************
//*		pXAI܂
//*		   : handle  LANIOnh
//***************************************************************************
DECLSPEC LELanioPulseModeContinuesOff(hLANIO handle);

//***************************************************************************
//*		pXAԂ擾܂
//*		   : handle  LANIOnh
//*		         mode    pXAԒȂ1AłȂ0
//***************************************************************************
DECLSPEC LELanioPulseModeContinuesGetState(hLANIO handle, int *mode);

//***************************************************************************
//*		^CvE8_^CvLANIO̊gPulseMode̋ʕݒ܂
//*		   : handle  LANIOnh
//*		         time    莞
//*		                 0:START-STOP  1:100msec  2:1sec  3:10sec
//*		         chatter `^O}
//*		                 0:Ȃ  1`3:ݒs  4`20:4`20msec
//***************************************************************************
DECLSPEC LELanioPulseModeSetConfig2(hLANIO handle, int time, int chatter);

//***************************************************************************
//*		^CvE8_^CvLANIO̊gPulseMode̋ʕݒ擾܂
//*		   : handle  LANIOnh
//*		         time    莞
//*		                 0:START-STOP  1:100msec  2:1sec  3:10sec
//*		         chatter `^O}
//*		                 0:Ȃ  1`3:ݒs  4`20:4`20msec
//***************************************************************************
DECLSPEC LELanioPulseModeGetConfig2(hLANIO handle, int *time, int *chatter);

//***************************************************************************
//*		^CvE8_^CvLANIO̊gPulseModeDIݒ܂
//*		   : handle  LANIOnh
//*		         pio     삷DI|[gԍBDI1=0ADI2=1...
//*		         enable  1ŃJEgL
//*		         edge    0ŗオA1ŗGbW
//***************************************************************************
DECLSPEC LELanioPulseModeSetConfigChannel(hLANIO handle, int pio, BOOL enable, BOOL edge);

//***************************************************************************
//*		^CvE8_^CvLANIO̊gPulseModeDIݒ擾܂
//*		   : handle  LANIOnh
//*		         pio     삷DI|[gԍBDI1=0ADI2=1...
//*		         enable  1ŃJEgL
//*		         edge    0ŗオA1ŗGbW
//***************************************************************************
DECLSPEC LELanioPulseModeGetConfigChannel(hLANIO handle, int pio, BOOL *enable, BOOL *edge);

//***************************************************************************
//*		^CvLANIO̊gPulseModẽ[A[gݒ܂
//*		   : handle    LANIOnh
//*		         pio       [A[gsDI|[gԍBDI1=0ADI2=1...
//*		         condition  0:[A[gȂ 1:ݒl菬 2:ݒlƈv 3:ݒl傫
//*		         val       ݒl
//***************************************************************************
DECLSPEC LELanioPulseModeSetAlart(hLANIO handle, int pio, int condition, unsigned long val);

//***************************************************************************
//*		^CvLANIO̊gPulseModẽ[A[gݒ擾܂
//*		   : handle    LANIOnh
//*		         pio       [A[gsDI|[gԍBDI1=0ADI2=1...
//*		         condition  0:[A[gȂ 1:ݒl菬 2:ݒlƈv 3:ݒl傫
//*		         val       ݒl
//***************************************************************************
DECLSPEC LELanioPulseModeGetAlart(hLANIO handle, int *pio, int *condition, unsigned long *val);

//***************************************************************************
//*		^CvE8_^CvLANIO̊gPulseModẽpX擾܂
//*		   : handle  LANIOnh
//*		         pio     삷DI|[gԍBDI1=0ADI2=1...
//*		         val     pXBI[o[t[Ԃ̏ꍇFFFFFFFF
//***************************************************************************
DECLSPEC LELanioPulseModeGetCount2(hLANIO handle, int pio, unsigned long *val);

//***************************************************************************
//*		8_^CvLANIO̖ʐMZbg̐ݒ܂B
//*		   : handle    LANIOnh
//*		         resettime ʐMɃZbg鎞Ԑݒ
//*		                   0:Zbg  1:5b  2:10b  3:20b  4:30b
//*		                   5:1  6:2  7:5  8:10  9:20  10:30
//***************************************************************************
DECLSPEC LELanioSetResetTime(hLANIO handle, int resettime);

