// LANIOLIB_sample_5PP.cpp : AvP[Vp̃Gg |Cg̒`
//

#include "stdafx.h"
#include "resource.h"
#include "stdio.h"
#include "LELANIO.h"

LRESULT CALLBACK DlgProc(HWND, UINT, WPARAM, LPARAM);
int load_ini_file( char *filename );

static HWND hDI1, hDI2, hDI3, hDI4, hDI5;
BOOL updateDI1, updateDI2, updateDI3, updateDI4, updateDI5;
HBITMAP active, nonactive;
hLANIO LANIO;

char title[16], ipaddress[16], strDI[5][16];

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow )
{
	if( load_ini_file( lpCmdLine ) == -1 ){
		MessageBox(NULL, ".init@C܂", NULL, MB_OK|MB_ICONEXCLAMATION);
		return -1;
	}

	active = LoadBitmap(hInstance, MAKEINTRESOURCE(IDB_ACTIVE));
	nonactive = LoadBitmap(hInstance, MAKEINTRESOURCE(IDB_NONACTIVE));

	DialogBox(hInstance, MAKEINTRESOURCE(IDD_LANIOLIB_SAMPLE_5PP), NULL, (DLGPROC)DlgProc);

	DeleteObject(nonactive);
	DeleteObject(active);
	return 0;
}

// \XV
void updateindicate()
{
	int input;
	LELanioInPioAll(LANIO, &input);	// SDǏ݂̓͂擾
	if( updateDI1 )	SendMessage(hDI1, STM_SETIMAGE, IMAGE_BITMAP, (LPARAM)(input&0x01 ? active : nonactive) );
	if( updateDI2 )	SendMessage(hDI2, STM_SETIMAGE, IMAGE_BITMAP, (LPARAM)(input&0x02 ? active : nonactive) );
	if( updateDI3 )	SendMessage(hDI3, STM_SETIMAGE, IMAGE_BITMAP, (LPARAM)(input&0x04 ? active : nonactive) );
	if( updateDI4 )	SendMessage(hDI4, STM_SETIMAGE, IMAGE_BITMAP, (LPARAM)(input&0x08 ? active : nonactive) );
	if( updateDI5 )	SendMessage(hDI5, STM_SETIMAGE, IMAGE_BITMAP, (LPARAM)(input&0x10 ? active : nonactive) );
}

LRESULT CALLBACK DlgProc(HWND hWnd, UINT msg, WPARAM wp, LPARAM lp)
{
	int nLANIO;
	switch(msg){
	case WM_INITDIALOG:
		SetWindowText(hWnd, title);

		LELanioInit();	// Cu
		nLANIO = LELanioSearch();	// LANIO
		if( nLANIO == 0 || nLANIO == -1 ){
			MessageBox(hWnd,"LANIO܂",NULL,MB_OK|MB_ICONEXCLAMATION);
			EndDialog(hWnd, IDOK);
			return TRUE;
		}
		LANIO = LELanioConnectByIpAddress(ipaddress);	// wIPAhXLANIOƐڑs
		if( LANIO == -1 ){
			MessageBox(hWnd,"ڑł܂",NULL,MB_OK|MB_ICONEXCLAMATION);
			EndDialog(hWnd, IDOK);
			return TRUE;
		}
		hDI1 = GetDlgItem(hWnd, IDC_INDICATE_DI1);
		hDI2 = GetDlgItem(hWnd, IDC_INDICATE_DI2);
		hDI3 = GetDlgItem(hWnd, IDC_INDICATE_DI3);
		hDI4 = GetDlgItem(hWnd, IDC_INDICATE_DI4);
		hDI5 = GetDlgItem(hWnd, IDC_INDICATE_DI5);
		SetWindowText(GetDlgItem(hWnd, IDC_STATIC_DI1), strDI[0]);
		SetWindowText(GetDlgItem(hWnd, IDC_STATIC_DI2), strDI[1]);
		SetWindowText(GetDlgItem(hWnd, IDC_STATIC_DI3), strDI[2]);
		SetWindowText(GetDlgItem(hWnd, IDC_STATIC_DI4), strDI[3]);
		SetWindowText(GetDlgItem(hWnd, IDC_STATIC_DI5), strDI[4]);
		SendMessage(hDI1, STM_SETIMAGE, IMAGE_BITMAP, (LPARAM)nonactive );
		SendMessage(hDI2, STM_SETIMAGE, IMAGE_BITMAP, (LPARAM)nonactive );
		SendMessage(hDI3, STM_SETIMAGE, IMAGE_BITMAP, (LPARAM)nonactive );
		SendMessage(hDI4, STM_SETIMAGE, IMAGE_BITMAP, (LPARAM)nonactive );
		SendMessage(hDI5, STM_SETIMAGE, IMAGE_BITMAP, (LPARAM)nonactive );
		updateDI1 = updateDI2 = updateDI3 = updateDI4 = updateDI5 = FALSE;
		updateindicate();
		SetTimer(hWnd,1,100,NULL);
		return TRUE;
	case WM_TIMER:
		updateindicate();
		return TRUE;
	case WM_COMMAND:
		switch(LOWORD(wp)){
		case IDC_AUTO_DI1:	updateDI1 = !updateDI1;	return TRUE;
		case IDC_AUTO_DI2:	updateDI2 = !updateDI2;	return TRUE;
		case IDC_AUTO_DI3:	updateDI3 = !updateDI3;	return TRUE;
		case IDC_AUTO_DI4:	updateDI4 = !updateDI4;	return TRUE;
		case IDC_AUTO_DI5:	updateDI5 = !updateDI5;	return TRUE;
		case IDOK:			LELanioClose(LANIO);	// LANIOƂ̐ڑI
							LELanioEnd();	// Cu̎gpI
							EndDialog(hWnd, IDOK);
							return TRUE;
		}
		break;
	}
	return FALSE;
}

// init@C
int load_ini_file( char *filename )
{
	strcpy(title, "SAMPLE");
	strcpy(ipaddress, "192.168.0.2");
	strcpy(strDI[0], "");
	strcpy(strDI[1], "");
	strcpy(strDI[2], "");
	strcpy(strDI[3], "");
	strcpy(strDI[4], "");

	if( *filename == NULL ){
		return 0;
	}

	// init@CJ
	FILE *file;
	file = fopen(filename, "r");
	if( file == NULL ){	// init@CȂ΂ȂɂȂ
		return -1;
	}
	// init@C
	char str[256];
	char tmp[256];
	while( fgets(str, 256, file) ){
		memcpy( tmp, str, 6 );
		tmp[6] = 0;
		strlwr( tmp );

		if( !strcmp( tmp, "@title" ) ){	// stitleƂ
			char *body = strchr( str, ',' );
			if( body != NULL ){			// J}ȂΖ
				body++;
				// CRALFkɂ
				char *LF = strchr( body, 0x0a );
				char *CR = strchr( body, 0x0d );
				if( LF != NULL )	*LF = NULL;
				if( CR != NULL )	*CR = NULL;

				body[15] = 0;	// ꍇA15ڂŐ؂
				strcpy( title, body );
			}
		}

		memcpy( tmp, str, 5 );
		tmp[5] = 0;
		strlwr( tmp );
		if( !strcmp( tmp, "@name" ) ){	// snameƂ
			char *body = strchr( str, ',' );
			if( body != NULL ){			// J}ȂΖ
				char number = *(body-1);
				if( number >= '1' && number <= '5' ){	// J}̃qgcOԂ̐
					body++;
					// CRALFkɂ
					char *LF = strchr( body, 0x0a );
					char *CR = strchr( body, 0x0d );
					if( LF != NULL )	*LF = NULL;
					if( CR != NULL )	*CR = NULL;

					body[15] = 0;	// 15ڂŐ؂
					strcpy( strDI[(number - '1')], body );
				}
			}
		}

		memcpy( tmp, str, 11 );
		tmp[11] = 0;
		strlwr( tmp );
		if( !strcmp( tmp, "@ip-address" ) ){	// sip-addressƂ
			char *body = strchr( str, ',' );
			if( body != NULL ){			// J}ȂΖ
				body++;
				// CRALFkɂ
				char *LF = strchr( body, 0x0a );
				char *CR = strchr( body, 0x0d );
				if( LF != NULL )	*LF = NULL;
				if( CR != NULL )	*CR = NULL;

				body[15] = 0;	// 15ڂŐ؂
				strcpy( ipaddress, body );
			}
		}
	}
	fclose(file);
	return 0;
}

