// LANIOLIB_sample_5R.cpp : AvP[Vp̃Gg |Cg̒`
//

#include "stdafx.h"
#include "resource.h"
#include "stdio.h"
#include "LELANIO.h"

LRESULT CALLBACK DlgProc(HWND, UINT, WPARAM, LPARAM);
int load_ini_file( char *filename );

static HWND hDO1, hDO2, hDO3, hDO4, hDO5;
HBITMAP active, nonactive;
hLANIO LANIO;

char title[16], ipaddress[16], strDO[5][16];

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow )
{
	if( load_ini_file( lpCmdLine ) == -1 ){
		MessageBox(NULL, ".init@C܂", NULL, MB_OK|MB_ICONEXCLAMATION);
		return -1;
	}

	active = LoadBitmap(hInstance, MAKEINTRESOURCE(IDB_ACTIVE));
	nonactive = LoadBitmap(hInstance, MAKEINTRESOURCE(IDB_NONACTIVE));

	DialogBox(hInstance, MAKEINTRESOURCE(IDD_LANIOLIB_SAMPLE_5R), NULL, (DLGPROC)DlgProc);

	DeleteObject(nonactive);
	DeleteObject(active);
	return 0;
}

// \XV
void updateindicate()
{
	int output;
	LELanioGetOutAll(LANIO, &output);	// SDǑ݂̏o͂擾
	SendMessage(hDO1, STM_SETIMAGE, IMAGE_BITMAP, (LPARAM)(output&0x01 ? active : nonactive) );
	SendMessage(hDO2, STM_SETIMAGE, IMAGE_BITMAP, (LPARAM)(output&0x02 ? active : nonactive) );
	SendMessage(hDO3, STM_SETIMAGE, IMAGE_BITMAP, (LPARAM)(output&0x04 ? active : nonactive) );
	SendMessage(hDO4, STM_SETIMAGE, IMAGE_BITMAP, (LPARAM)(output&0x08 ? active : nonactive) );
	SendMessage(hDO5, STM_SETIMAGE, IMAGE_BITMAP, (LPARAM)(output&0x10 ? active : nonactive) );
}

// eDȌo͂؂ւ
void changeoutput(int DO)
{
	BOOL output;
	LELanioGetOut(LANIO, DO, &output);	// w肵DǑ݂̏o͂擾
	output = !output;
	LELanioOutPio(LANIO, DO, output);	// DOo͂ݒ肷
	updateindicate();
}

LRESULT CALLBACK DlgProc(HWND hWnd, UINT msg, WPARAM wp, LPARAM lp)
{
	int nLANIO;
	switch(msg){
	case WM_INITDIALOG:
		SetWindowText(hWnd, title);

		LELanioInit();	// Cu
		nLANIO = LELanioSearch();	// LANIO
		if( nLANIO == 0 || nLANIO == -1 ){
			MessageBox(hWnd,"LANIO܂",NULL,MB_OK|MB_ICONEXCLAMATION);
			EndDialog(hWnd, IDOK);
			return TRUE;
		}
		LANIO = LELanioConnectByIpAddress(ipaddress);	// wIPAhXLANIOƐڑs
		if( LANIO == -1 ){
			MessageBox(hWnd,"ڑł܂",NULL,MB_OK|MB_ICONEXCLAMATION);
			EndDialog(hWnd, IDOK);
			return TRUE;
		}
		hDO1 = GetDlgItem(hWnd, IDC_INDICATE_DO1);
		hDO2 = GetDlgItem(hWnd, IDC_INDICATE_DO2);
		hDO3 = GetDlgItem(hWnd, IDC_INDICATE_DO3);
		hDO4 = GetDlgItem(hWnd, IDC_INDICATE_DO4);
		hDO5 = GetDlgItem(hWnd, IDC_INDICATE_DO5);
		SetWindowText(GetDlgItem(hWnd, IDC_STATIC_DO1), strDO[0]);
		SetWindowText(GetDlgItem(hWnd, IDC_STATIC_DO2), strDO[1]);
		SetWindowText(GetDlgItem(hWnd, IDC_STATIC_DO3), strDO[2]);
		SetWindowText(GetDlgItem(hWnd, IDC_STATIC_DO4), strDO[3]);
		SetWindowText(GetDlgItem(hWnd, IDC_STATIC_DO5), strDO[4]);
		updateindicate();
		return TRUE;
	case WM_COMMAND:
		switch(LOWORD(wp)){
		case IDC_ONOFF_DO1:	changeoutput(0);	
							return TRUE;
		case IDC_ONOFF_DO2:	changeoutput(1);	
							return TRUE;
		case IDC_ONOFF_DO3:	changeoutput(2);	
							return TRUE;
		case IDC_ONOFF_DO4:	changeoutput(3);	
							return TRUE;
		case IDC_ONOFF_DO5:	changeoutput(4);	
							return TRUE;
		case IDOK:			LELanioClose(LANIO);	// LANIOƂ̐ڑI
							LELanioEnd();	// Cu̎gpI
							EndDialog(hWnd, IDOK);
							return TRUE;
		}
		break;
	}
	return FALSE;
}

// init@C
int load_ini_file( char *filename )
{
	strcpy(title, "SAMPLE");
	strcpy(ipaddress, "192.168.0.2");
	strcpy(strDO[0], "");
	strcpy(strDO[1], "");
	strcpy(strDO[2], "");
	strcpy(strDO[3], "");
	strcpy(strDO[4], "");

	if( *filename == NULL ){
		return 0;
	}

	// init@CJ
	FILE *file;
	file = fopen(filename, "r");
	if( file == NULL ){	// init@CȂ΂ȂɂȂ
		return -1;
	}
	// init@C
	char str[256];
	char tmp[256];
	while( fgets(str, 256, file) ){
		memcpy( tmp, str, 6 );
		tmp[6] = 0;
		strlwr( tmp );

		if( !strcmp( tmp, "@title" ) ){	// stitleƂ
			char *body = strchr( str, ',' );
			if( body != NULL ){			// J}ȂΖ
				body++;
				// CRALFkɂ
				char *LF = strchr( body, 0x0a );
				char *CR = strchr( body, 0x0d );
				if( LF != NULL )	*LF = NULL;
				if( CR != NULL )	*CR = NULL;

				body[15] = 0;	// ꍇA15ڂŐ؂
				strcpy( title, body );
			}
		}

		memcpy( tmp, str, 5 );
		tmp[5] = 0;
		strlwr( tmp );
		if( !strcmp( tmp, "@name" ) ){	// snameƂ
			char *body = strchr( str, ',' );
			if( body != NULL ){			// J}ȂΖ
				char number = *(body-1);
				if( number >= '1' && number <= '5' ){	// J}̃qgcOԂ̐
					body++;
					// CRALFkɂ
					char *LF = strchr( body, 0x0a );
					char *CR = strchr( body, 0x0d );
					if( LF != NULL )	*LF = NULL;
					if( CR != NULL )	*CR = NULL;

					body[15] = 0;	// 15ڂŐ؂
					strcpy( strDO[(number - '1')], body );
				}
			}
		}

		memcpy( tmp, str, 11 );
		tmp[11] = 0;
		strlwr( tmp );
		if( !strcmp( tmp, "@ip-address" ) ){	// sip-addressƂ
			char *body = strchr( str, ',' );
			if( body != NULL ){			// J}ȂΖ
				body++;
				// CRALFkɂ
				char *LF = strchr( body, 0x0a );
				char *CR = strchr( body, 0x0d );
				if( LF != NULL )	*LF = NULL;
				if( CR != NULL )	*CR = NULL;

				body[15] = 0;	// 15ڂŐ؂
				strcpy( ipaddress, body );
			}
		}
	}
	fclose(file);
	return 0;
}

