using System.Runtime.InteropServices;
namespace LEAPI
{
    public class LELanio
    {
        //***************************************************************************
        //* ^`A萔`
        //***************************************************************************

        //***************************************************************************
        //* LELanioGetLastErrorԂG[R[h
        //***************************************************************************
        public enum LANIOERROR : int
        {
            LELANIOERR_NOINIT = 1,			//* Ă܂BLELanioInitsĂB
            LELANIOERR_NOLANIO,				//* ʁALANIOł܂łB
            LELANIOERR_NOTEXIST,			//* ŔLANIO葽lw肵܂B
            LELANIOERR_NOTFOUND,			//* w肳ꂽLANIO𔭌ł܂łB
            LELANIOERR_NOCONNECTED,			//* LANIOƐڑĂ܂BLELanioConnectsĂB
            LELANIOERR_INVALIDOPERATION,	//* w肳ꂽ͎sł܂B
            LELANIOERR_ALREADY_CONNECTED,	//* łɐڑĂ܂B
            LELANIOERR_OVERCONNECTMAX,		//* ڑő吔𒴉߂܂B
            LELANIOERR_INVALIDRETURNVALUE,	//* sȖ߂lԂ܂B
        }
        //***************************************************************************
        //* LELanioGetModelŎ擾LANIOf
        //***************************************************************************
        public enum LANIOMODEL : int
        {
            LA2R3PP = 0,
            LA3R2P  = 1,		// LA-3R2P-P܂
            LA7P    = 2,		// LA-7P-P / LA-7P-A܂
            LA5R    = 3,
            LA5T2S  = 4,		// LA-5T2S-P܂
            LA5PP   = 5,
            LA3R3PP = 6,
            LA232R  = 7,
            LA232T  = 8,
            LA485R  = 9,
            LA485T  = 10,
            LA4R4PP = 17,
            LA8R    = 19,
            LA8T    = 20,
            LA8PP   = 21,
            LA4T4SP = 22,
            LAN2R2P = 25,
            NO_GETMODEL = -1,
        };
        //***************************************************************************
        //* AIAG[擾֐
        //***************************************************************************

        //***************************************************************************
        //*		LANIOCu܂B
        //***************************************************************************
        [DllImport("LELanio.dll", EntryPoint = "LELanioInit")]
        public static extern int Init();

        //***************************************************************************
        //*		LANIOCu̎gpI܂B
        //***************************************************************************
        [DllImport("LELanio.dll", EntryPoint = "LELanioEnd")]
        public static extern int End();

        //***************************************************************************
        //*		OɔG[ԍ擾܂B
        //*		߂l : G[̏Ԃ܂
        //***************************************************************************
        [DllImport("LELanio.dll", EntryPoint = "LELanioGetLastError")]
        public static extern int GetLastError();

        //***************************************************************************
        //* LANIO֐
        //***************************************************************************

        //***************************************************************************
        //*		ILANIOIDModel擾@\ɂĂ̐ݒ܂B
        //*		   : enable  ̋@\gpꍇTRUE(1)AȂꍇFALSE(0)
        //*		         port    IDModel擾VÃ|[gԍ
        //***************************************************************************
        [DllImport("LELanio.dll", EntryPoint = "LELanioSetAutoRequestIdModel")]
        public static extern int SetAutoRequestIdModel(int enable, int port);

        //***************************************************************************
        //*		LANɂLANIO܂B
        //*		   : msec    ^CAEgԁiP mbj
        //*		߂l : LANIO̐BłȂꍇ0BG[-1
        //***************************************************************************
        [DllImport("LELanio.dll", EntryPoint = "LELanioSearch")]
        public static extern int Search(int msec);

        //***************************************************************************
        //* LANIO擾֐
        //***************************************************************************

        //***************************************************************************
        //*		LANIOIPAhX擾܂B
        //*		   : lanio       LANIOԍ
        //*		         ipaddress   IPAhX擾obt@ւ̎Q(16byteKv)
        //***************************************************************************
        [DllImport("LELanio.dll", EntryPoint = "LELanioGetIpAddress")]
        public static extern int GetIpAddress(int lanio, System.Text.StringBuilder ipaddress);

        //***************************************************************************
        //*		LANIOMACAhX擾܂B
        //*		   : lanio       LANIOԍ
        //*		         macaddress  MACAhX擾obt@ւ̎Q(6byteKv)
        //***************************************************************************
        [DllImport("LELanio.dll", EntryPoint = "LELanioGetMacAddress")]
        public static extern int GetMacAddress(int lanio, byte[] macaddress);

        //***************************************************************************
        //*		LANIOIDԍ擾܂B
        //*		   : lanio   LANIOԍ
        //*		         id      LANIOID擾obt@ւ̎Q
        //***************************************************************************
        [DllImport("LELanio.dll", EntryPoint = "LELanioGetId")]
        public static extern int GetId(int lanio, ref int id);

        //***************************************************************************
        //*		LANIÕf擾܂B
        //*		   : lanio   LANIOԍ
        //*		         model   LANIÕf擾obt@ւ̎Q
        //***************************************************************************
        [DllImport("LELanio.dll", EntryPoint = "LELanioGetModel")]
        public static extern int GetModel(int lanio, ref int model);

        //***************************************************************************
        //*		LANIOɑ΂IDƃfԍ₵܂B
        //*		   : lanio   LANIOԍ
        //*		         id      LANIOID擾obt@ւ̎Q
        //*		         model   LANIÕf擾obt@ւ̎Q
        //***************************************************************************
        [DllImport("LELanio.dll", EntryPoint = "LELanioRequestIdModel")]
        public static extern int RequestIdModel(int lanio, ref int id, ref int model);

        //***************************************************************************
        //* LANIOڑ֐
        //***************************************************************************

        //***************************************************************************
        //*		LELanioSearchɂĔꂽԂw肵Đڑ܂B
        //*		   : lanio   LANIOԍ
        //*		߂l : G[-1AILANIOnhԂ܂
        //***************************************************************************
        [DllImport("LELanio.dll", EntryPoint = "LELanioConnect")]
        public static extern int Connect(int lanio);

        //***************************************************************************
        //*		IDƃfw肵Đڑ܂B
        //*		   : id      LANIOIDԍ
        //*		         model   LANIÕf
        //*		߂l : G[-1AILANIOnhԂ܂
        //***************************************************************************
        [DllImport("LELanio.dll", EntryPoint = "LELanioConnectByIdModel")]
        public static extern int ConnectByIdModel(int id, int model);

        //***************************************************************************
        //*		IPAhXw肵Đڑ܂B
        //*		   : ipaddress   IPAhX
        //*		߂l : G[-1AILANIOnhԂ܂
        //***************************************************************************
        [DllImport("LELanio.dll", EntryPoint = "LELanioConnectByIpAddress")]
        public static extern int ConnectByIpAddress(string ipaddress);

        //***************************************************************************
        //*		MACAhXw肵Đڑ܂B
        //*		   : macaddress  MACAhXobt@ւ̎Q
        //*		߂l : G[-1AILANIOnhԂ܂
        //***************************************************************************
        [DllImport("LELanio.dll", EntryPoint = "LELanioConnectByMacAddress")]
        public static extern int ConnectByMacAddress(byte[] macaddress);

        //***************************************************************************
        //*		IPAhXURLw肵Đڑ܂B
        //*		   : address IPAhX܂urlobt@ւ̎Q
        //*		         msec    ^CAEgԁiP mbj
        //*		߂l : G[-1AILANIOnhԂ܂
        //***************************************************************************
        [DllImport("LELanio.dll", EntryPoint = "LELanioConnectDirect")]
        public static extern int ConnectDirect(string address, int msec);

        //***************************************************************************
        //*		IPAhXURLA|[gԍw肵Đڑ܂BڑUDPgp܂B
        //*		   : address IPAhX܂urlobt@ւ̎Q
        //*		         msec    ^CAEgԁiP mbj
        //*		         port    |[gԍ
        //*		߂l : G[-1AILANIOnhԂ܂
        //***************************************************************************
        [DllImport("LELanio.dll", EntryPoint = "LELanioConnectDirect2")]
        public static extern int ConnectDirect2(string address, int msec, int port);

        //***************************************************************************
        //* LANIOؒf֐
        //***************************************************************************

        //***************************************************************************
        //*		LANIOƂ̐ڑؒf܂B
        //*		   : handle  LANIOnh
        //***************************************************************************
        [DllImport("LELanio.dll", EntryPoint = "LELanioClose")]
        public static extern int Close(int handle);

        //***************************************************************************
        //* o͊֐
        //***************************************************************************

        //***************************************************************************
        //*		LANIODO𑀍삵܂B_Pʂ̑Ɏgp܂B
        //*		   : handle  LANIOnh
        //*		         pio     삷DO|[gԍBDO1=0ADO2=1...
        //*		         active  ONȂ1AOFFȂ0
        //***************************************************************************
        [DllImport("LELanio.dll", EntryPoint = "LELanioOutPio")]
        public static extern int OutPio(int handle, int pio, int active);

        //***************************************************************************
        //*		LANIODO𑀍삵܂BSĂDOɑ΂Ăɑ삷鎞Ɏgp܂B
        //*		   : handle  LANIOnh
        //*		         piobit  DO|[g̐ݒBŉʃrbgDO1ADO2...ɑΉ܂
        //***************************************************************************
        [DllImport("LELanio.dll", EntryPoint = "LELanioOutPioAll")]
        public static extern int OutPioAll(int handle, int piobit);

        //***************************************************************************
        //*		LANIODI擾܂B_Pʂ̎擾Ɏgp܂B
        //*		   : handle  LANIOnh
        //*		         pio     擾DI|[gԍBDI1=0ADI2=1...ɑΉ܂
        //*		         active  ONȂ1AOFFȂ0obt@ւ̎Q
        //***************************************************************************
        [DllImport("LELanio.dll", EntryPoint = "LELanioInPio")]
        public static extern int InPio(int handle, int pio, ref int active);

        //***************************************************************************
        //*		LANIODI擾܂BSĂDIɑ΂ĂɎ擾鎞Ɏgp܂B
        //*		   : handle  LANIOnh
        //*		         piobit  DI|[g̓eobt@ւ̎Q
        //*		                 ŉʃrbgDI1ADI2...
        //***************************************************************************
        [DllImport("LELanio.dll", EntryPoint = "LELanioInPioAll")]
        public static extern int InPioAll(int handle, ref int piobit);

        //***************************************************************************
        //*		LANIǑ݂DOԂ擾܂B_Pʂ̎擾Ɏgp܂B
        //*		   : handle  LANIOnh
        //*		         pio     擾DO|[gԍBDO1=0ADO2=1...ɑΉ܂
        //*		         active  ONȂ1AOFFȂ0obt@ւ̎Q
        //***************************************************************************
        [DllImport("LELanio.dll", EntryPoint = "LELanioGetOut")]
        public static extern int GetOut(int handle, int pio, ref int active);

        //***************************************************************************
        //*		LANIǑ݂DOԂ擾܂BSĂDOɑ΂ĂɎ擾鎞Ɏgp܂B
        //*		   : handle  LANIOnh
        //*		         piobit  DO|[g̓eobt@ւ̎Q
        //*		                 ŉʃrbgDO1ADO2...
        //***************************************************************************
        [DllImport("LELanio.dll", EntryPoint = "LELanioGetOutAll")]
        public static extern int GetOutAll(int handle, ref int piobit);

        //***************************************************************************
        //*		LANIȌo͒[qON/OFF̊Jn/~s܂
        //*		   : handle  LANIOnh
        //*		         active  ON/OFFJn=0ȊOA~=0
        //***************************************************************************
        [DllImport("LELanio.dll", EntryPoint = "LELanioSetAutoSwitchingActive")]
        public static extern int SetAutoSwitchingActive(int handle, int active);

        //***************************************************************************
        //*		LANIȌo͒[qON/OFF̊Jn/~ݒ擾܂
        //*		   : handle  LANIOnh
        //*		         active  ON/OFFԂobt@ւ̎Q
        //***************************************************************************
        [DllImport("LELanio.dll", EntryPoint = "LELanioGetAutoSwitchingActive")]
        public static extern int GetAutoSwitchingActive(int handle, ref int active);

        //***************************************************************************
        //*		LANIȌo͒[qON/OFF̎ݒ肵܂
        //*		   : handle  LANIOnh
        //*		         msec    iP mbj
        //***************************************************************************
        [DllImport("LELanio.dll", EntryPoint = "LELanioSetAutoSwitchingTime")]
        public static extern int SetAutoSwitchingTime(int handle, int msec);

        //***************************************************************************
        //*		LANIȌo͒[qON/OFF̎ݒ擾܂
        //*		   : handle  LANIOnh
        //*		         msec    iP mbjobt@ւ̎Q
        //***************************************************************************
        [DllImport("LELanio.dll", EntryPoint = "LELanioGetAutoSwitchingTime")]
        public static extern int GetAutoSwitchingTime(int handle, ref int msec);

        //***************************************************************************
        //*		LANIȌo͒[qON/OFFsDOݒ肵܂B
        //*		   : handle  LANIOnh
        //*		         autoswdo ŉʃrbgADO1`DO5ŎON/OFFs[q1
        //***************************************************************************
        [DllImport("LELanio.dll", EntryPoint = "LELanioSetAutoSwitchingPio")]
        public static extern int SetAutoSwitchingPio(int handle, int autoswdo);

        //***************************************************************************
        //*		LANIȌo͒[qON/OFFsDOݒ擾܂
        //*		   : handle  LANIOnh
        //*		         autoswdo ON/OFFsDOݒ擾obt@ւ̎Q
        //***************************************************************************
        [DllImport("LELanio.dll", EntryPoint = "LELanioGetAutoSwitchingPio")]
        public static extern int GetAutoSwitchingPio(int handle, ref int autoswdo);

        //***************************************************************************
        //*		8_^CvLANIȌo͒[qON/OFF̃`lʎݒ肵܂
        //*		   : handle   LANIOnh
        //*		         pio      ݒ肷DO|[gԍBDO1=0ADO2=1...ɑΉ܂
        //*		         msec_on  ONԁi100msecPʁAݒ͈1-25500j
        //*		         msec_off OFFԁi100msecPʁAݒ͈1-25500j
        //***************************************************************************
        [DllImport("LELanio.dll", EntryPoint = "LELanioSetAutoSwitchingChannel")]
        public static extern int LELanioSetAutoSwitchingChannel(int handle, int pio, int msec_on, int msec_off);

        //***************************************************************************
        //*		8_^CvLANIȌo͒[qON/OFF̃`lʎݒ擾܂
        //*		   : handle   LANIOnh
        //*		         pio      擾DO|[gԍBDO1=0ADO2=1...ɑΉ܂
        //*		         msec_on  ONԁi100msecPʁj
        //*		         msec_off OFFԁi100msecPʁj
        //***************************************************************************
        [DllImport("LELanio.dll", EntryPoint = "LELanioGetAutoSwitchingChannel")]
        public static extern int LELanioGetAutoSwitchingChannel(int handle, int pio, ref int msec_on, ref int msec_off);

        //***************************************************************************
        //*		LANIO̖ʐMԂɂȂ̐ڑێԂݒ肷
        //*		   : handle  LANIOnh
        //*		         time    
        //*		                 0x00:ؒf 0x04: 3sec  0x08:50sec  0x0c:10min
        //*		                 0x01:300ms    0x05: 5sec  0x09: 1min  0x0d:30min
        //*		                 0x02:500ms    0x06:10sec  0x0a: 3min  0x0e:50min
        //*		                 0x03: 1sec    0x07:30sec  0x0b: 5min  0x0f:
        //***************************************************************************
        [DllImport("LELanio.dll", EntryPoint = "LELanioSetDisconnectionTime")]
        public static extern int SetDisconnectionTime(int handle, int time);

        //***************************************************************************
        //*		LANIO̖ʐMԂɂȂ̐ڑێԂ擾
        //*		   : handle  LANIOnh
        //*		         time    Ԃ擾obt@ւ̎Q
        //*		                 0x00:ؒf 0x04: 3sec  0x08:50sec  0x0c:10min
        //*		                 0x01:300ms    0x05: 5sec  0x09: 1min  0x0d:30min
        //*		                 0x02:500ms    0x06:10sec  0x0a: 3min  0x0e:50min
        //*		                 0x03: 1sec    0x07:30sec  0x0b: 5min  0x0f:
        //***************************************************************************
        [DllImport("LELanio.dll", EntryPoint = "LELanioGetDisconnectionTime")]
        public static extern int GetDisconnectionTime(int handle, ref int time);

        //***************************************************************************
        //*		LANIO̒ʒmԂݒ肷
        //*		   : handle  LANIOnh
        //*		                 0x00:ʒmȂ 0x04: 3min     0x08:ݒ֎~  0x0c:ݒ֎~
        //*		                 0x01:10sec    0x05:ݒ֎~  0x09:ݒ֎~  0x0d:ݒ֎~
        //*		                 0x02:30sec    0x06:ݒ֎~  0x0a:ݒ֎~  0x0e:ݒ֎~
        //*		                 0x03:60sec    0x07:ݒ֎~  0x0b:ݒ֎~  0x0f:ݒ֎~
        //***************************************************************************
        [DllImport("LELanio.dll", EntryPoint = "LELanioSetNoticeTime")]
        public static extern int SetNoticeTime(int handle, int time);

        //***************************************************************************
        //*		LANIO̒ʒmԂ擾
        //*		   : handle  LANIOnh
        //*		                 0x00:ʒmȂ 0x04: 3min   0x08:  ---   0x0c:  ---
        //*		                 0x01:10sec    0x05:  ---   0x09:  ---   0x0d:  ---
        //*		                 0x02:30sec    0x06:  ---   0x0a:  ---   0x0e:  ---
        //*		                 0x03:60sec    0x07:  ---   0x0b:  ---   0x0f:  ---
        //***************************************************************************
        [DllImport("LELanio.dll", EntryPoint = "LELanioGetNoticeTime")]
        public static extern int GetNoticeTime(int handle, ref int time);

        //***************************************************************************
        //*		LANIÕ`^O̊Ԃݒ肷
        //*		   : handle  LANIOnh
        //*		         time    (msP 4ms`20msj
        //***************************************************************************
        [DllImport("LELanio.dll", EntryPoint = "LELanioSetDiDetectTime")]
        public static extern int SetDiDetectTime(int handle, int time);

        //***************************************************************************
        //*		LANIÕ`^O̊Ԃ擾
        //*		   : handle  LANIOnh
        //*		         time    Ԃ擾obt@ւ̎Q(msP 4ms`20msj
        //***************************************************************************
        [DllImport("LELanio.dll", EntryPoint = "LELanioGetDiDetectTime")]
        public static extern int GetDiDetectTime(int handle, ref int time);

        //***************************************************************************
        //*		LANIÕ[A[gs͒[qݒ肵܂
        //*		   : handle  LANIOnh
        //*		         enable  [A[gsrbg1Ŏw
        //*		                 ŉʃrbgDI1ADI2...
        //***************************************************************************
        [DllImport("LELanio.dll", EntryPoint = "LELanioSetDiMailEnable")]
        public static extern int SetDiMailEnable(int handle, int enable);

        //***************************************************************************
        //*		LANIÕ[A[gs͒[q擾܂
        //*		   : handle  LANIOnh
        //*		         enable  [A[gsrbg1Ŏw
        //*		                 ŉʃrbgDI1ADI2...
        //***************************************************************************
        [DllImport("LELanio.dll", EntryPoint = "LELanioGetDiMailEnable")]
        public static extern int GetDiMailEnable(int handle, ref int enable);

        //***************************************************************************
        //*		LANIÕ[A[gs_Ԃݒ肵܂
        //*		   : handle  LANIOnh
        //*		         logic   HIŃ[A[gsrbg1Ŏw
        //*		                 ŉʃrbgDI1ADI2...
        //***************************************************************************
        [DllImport("LELanio.dll", EntryPoint = "LELanioSetDiMailLogic")]
        public static extern int SetDiMailLogic(int handle, int logic);

        //***************************************************************************
        //*		LANIÕ[A[gs_Ԃ擾܂
        //*		   : handle  LANIOnh
        //*		         logic   HIŃ[A[gsrbg1Ŏw
        //*		                 ŉʃrbgDI1ADI2...
        //***************************************************************************
        [DllImport("LELanio.dll", EntryPoint = "LELanioGetDiMailLogic")]
        public static extern int GetDiMailLogic(int handle, ref int logic);

        //***************************************************************************
        //*		PulseModeɓ܂
        //*		   : handle  LANIOnh
        //***************************************************************************
        [DllImport("LELanio.dll", EntryPoint = "LELanioPulseModeOn")]
        public static extern int PulseModeOn(int handle);

        //***************************************************************************
        //*		PulseModeI܂
        //*		   : handle  LANIOnh
        //***************************************************************************
        [DllImport("LELanio.dll", EntryPoint = "LELanioPulseModeOff")]
        public static extern int PulseModeOff(int handle);

        //***************************************************************************
        //*		PulseModeԂ擾܂
        //*		   : handle  LANIOnh
        //*		         mode    PulseModeԁB[hȂ1A[hłȂ0
        //***************************************************************************
        [DllImport("LELanio.dll", EntryPoint = "LELanioPulseModeGetState")]
        public static extern int PulseModeGetState(int handle, ref int mode);

        //***************************************************************************
        //*		PulseModẽpX擾܂
        //*		   : handle  LANIOnh
        //*		         value   pXBI[o[t[Ԃ̏ꍇ-1
        //***************************************************************************
        [DllImport("LELanio.dll", EntryPoint = "LELanioPulseModeGetCount")]
        public static extern int PulseModeGetCount(int handle, ref int value);

        //***************************************************************************
        //*		PulseMode̐ݒ܂
        //*		   : handle  LANIOnh
        //*		         pio     삷DI|[gԍBDI1=0ADI2=1...
        //*		         edge    0ŗオA1ŗGbW
        //*		         time    莞
        //*		                 0:START-STOP  1:100msec  2:1sec  3:10sec
        //*		         chatter `^O}
        //*		                 0:Ȃ  1`3:ݒs  4`20:4`20msec
        //***************************************************************************
        [DllImport("LELanio.dll", EntryPoint = "LELanioPulseModeSetConfig")]
        public static extern int PulseModeSetConfig(int handle, int pio, int edge, int time, int chatter);

        //***************************************************************************
        //*		PulseMode̐ݒ擾܂
        //*		   : handle  LANIOnh
        //*		         pio     삷DI|[gԍBDI1=0ADI2=1...
        //*		         edge    0ŗオA1ŗGbW
        //*		         time    莞
        //*		                 0:START-STOP  1:100msec  2:1sec  3:10sec
        //*		         chatter `^O}
        //*		                 0:Ȃ  1`3:ݒs  4`20:4`20msec
        //***************************************************************************
        [DllImport("LELanio.dll", EntryPoint = "LELanioPulseModeGetConfig")]
        public static extern int PulseModeGetConfig(int handle, ref int pio, ref int edge, ref int time, ref int chatter);

        //***************************************************************************
        //*		^CvE8_^CvLANIOLANIO̊gPulseMode̋ʕݒ܂
        //*		   : handle  LANIOnh
        //*		         time    莞
        //*		                 0:START-STOP  1:100msec  2:1sec  3:10sec
        //*		         chatter `^O}
        //*		                 0:Ȃ  1`3:ݒs  4`20:4`20msec
        //***************************************************************************
        [DllImport("LELanio.dll", EntryPoint = "LELanioPulseModeSetConfig2")]
        public static extern int LELanioPulseModeSetConfig2(int handle, int time, int chatter);

        //***************************************************************************
        //*		^CvE8_^CvLANIOLANIO̊gPulseMode̋ʕݒ擾܂
        //*		   : handle  LANIOnh
        //*		         time    莞
        //*		                 0:START-STOP  1:100msec  2:1sec  3:10sec
        //*		         chatter `^O}
        //*		                 0:Ȃ  1`3:ݒs  4`20:4`20msec
        //***************************************************************************
        [DllImport("LELanio.dll", EntryPoint = "LELanioPulseModeGetConfig2")]
        public static extern int LELanioPulseModeGetConfig2(int handle, ref int time, ref int chatter);

        //***************************************************************************
        //*		^CvE8_^CvLANIOLANIO̊gPulseModeDIݒ܂
        //*		   : handle  LANIOnh
        //*		         pio     삷DI|[gԍBDI1=0ADI2=1...
        //*		         enable  1ŃJEgL
        //*		         edge    0ŗオA1ŗGbW
        //***************************************************************************
        [DllImport("LELanio.dll", EntryPoint = "LELanioPulseModeSetConfigChannel")]
        public static extern int LELanioPulseModeSetConfigChannel(int handle, int pio, int enable, int edge);

        //***************************************************************************
        //*		^CvE8_^CvLANIOLANIO̊gPulseModeDIݒ擾܂
        //*		   : handle  LANIOnh
        //*		         pio     삷DI|[gԍBDI1=0ADI2=1...
        //*		         enable  1ŃJEgL
        //*		         edge    0ŗオA1ŗGbW
        //***************************************************************************
        [DllImport("LELanio.dll", EntryPoint = "LELanioPulseModeGetConfigChannel")]
        public static extern int LELanioPulseModeGetConfigChannel(int handle, int pio, ref int enable, ref int edge);

        //***************************************************************************
        //*		^CvLANIO̊gPulseModẽ[A[gݒ܂
        //*		   : handle    LANIOnh
        //*		         pio       [A[gsDI|[gԍBDI1=0ADI2=1...
        //*		         condition  0:[A[gȂ 1:ݒl菬 2:ݒlƈv 3:ݒl傫
        //*		         val       ݒl
        //***************************************************************************
        [DllImport("LELanio.dll", EntryPoint = "LELanioPulseModeSetAlart")]
        public static extern int LELanioPulseModeSetAlart(int handle, int pio, int condition, uint val);

        //***************************************************************************
        //*		^CvLANIO̊gPulseModẽ[A[gݒ擾܂
        //*		   : handle    LANIOnh
        //*		         pio       [A[gsDI|[gԍBDI1=0ADI2=1...
        //*		         condition  0:[A[gȂ 1:ݒl菬 2:ݒlƈv 3:ݒl傫
        //*		         val       ݒl
        //***************************************************************************
        [DllImport("LELanio.dll", EntryPoint = "LELanioPulseModeGetAlart")]
        public static extern int LELanioPulseModeGetAlart(int handle, ref int pio, ref int condition, ref uint val);

        //***************************************************************************
        //*		^CvE8_^CvLANIO̊gPulseModẽpX擾܂
        //*		   : handle  LANIOnh
        //*		         pio     삷DI|[gԍBDI1=0ADI2=1...
        //*		         val     pXBI[o[t[Ԃ̏ꍇFFFFFFFF
        //***************************************************************************
        [DllImport("LELanio.dll", EntryPoint = "LELanioPulseModeGetCount2")]
        public static extern int LELanioPulseModeGetCount2(int handle, int pio, ref uint val);

       //***************************************************************************
        //*		8_^CvLANIO̖ʐMZbg̐ݒ܂B
        //*		   : handle    LANIOnh
        //*		         resettime 삷DI|[gԍBDI1=0ADI2=1...
        //*		                   0:Zbg  1:5b  2:10b  3:20b  4:30b
        //*		                   5:1  6:2  7:5  8:10  9:20  10:30
        //***************************************************************************
        [DllImport("LELanio.dll", EntryPoint = "LELanioSetResetTime")]
        public static extern int LELanioSetResetTime(int handle, int resettime);
    }
}